#pragma once

#include "UnstructuredGrid.h"
#include "VectorAttributes.h"
#include <set>
#include <vector>


using namespace std;




class UnstructuredGrid3D : public UnstructuredGrid
{
public: 

typedef set<int> CellsOfPoint;							//Set of cell-indexes using a given vertex

					UnstructuredGrid3D(int P,int C): UnstructuredGrid(P,C),pointNormals(P),faceNormals(C), pointsZ(P)
					{ }	 
					 	
void				getPoint(int i,float* p);

void				setPoint(int i,float* p);		

void				normalize();

void				computeFaceNormals();

void				computeVertexNormals();

void				computePointTriangles();			//Initialize the map of cells sharing each vertex (point2cells)

VectorAttributes&	getFaceNormals()
					{ return faceNormals; }

VectorAttributes&	getPointNormals()
					{ return pointNormals; }

const CellsOfPoint& cellsOfPoint(int i)					//Return indexes of all cells using point-index 'i'
					{ return point2cells[i]; }

void				closest(float radius,int pid,int maxNeighbors,vector<int>& vertices);		
														//Returns in 'vertices' all vertex-IDs which are connected to 'pid' by a path on 
														//the mesh surface which is contained in the 3D ball of radius 'radius' centered
														//at 'pid'. Maximum 'maxNeighbors' are returned.
private:

vector<float>			pointsZ;
VectorAttributes		pointNormals;
VectorAttributes		faceNormals;
vector<CellsOfPoint>	point2cells;					//Stores, for each point-index, the indexes of all cells using that point
};



